#ifndef _SCPP_UDPConn_h
#define _SCPP_UDPConn_h

#include "SocketsGlobal.h"
#include "TCPSocket.h"

#include <errno.h>

active class UDPConn : public UDPBase {

  struct sockaddr_in client;  
  struct sockaddr_in server;

  int retval;
  int retvalclose;
  TCPSocket *tcpsd;
  int initfailed;

  @UDPConn();

 public:

//  UDPBase::Send;
//  UDPBase::Recv;

  void IsConnectionClosed();

  ~UDPConn();

  UDPConn(int usd, struct sockaddr_in *client, TCPSocket *tcpsd);
  UDPConn(int &returnV, char* hostname, int port);
};

active class UDPConnDaemon {

  struct sockaddr_in server;
  struct sockaddr_in client;
  UnixSocket *udpsd;
  int udpsddesc;
  TCPSocket *tcpsd;
  TCPSocketDaemon *tcpdaemon;
  int portnum;
  int initfailed;

  @UDPConnDaemon();

 public:

  UDPConn* SocketCreated();

  ~UDPConnDaemon() { }
 
  UDPConnDaemon(int &returnV, int portnum);

};
#endif
