/***********************************************************************
*   $Id$
*   descr:      class RandomIntGenerator
*               to generate random integer number in range [min,max]
*
*   author:     DIVIN Abel
*
*   $Log$
*
************************************************************************/

#ifndef _RANDOM_INT_GENERATOR_H
#define _RANDOM_INT_GENERATOR_H

class RandomIntGenerator {
  int min;
  int max;

public:

  // ------------------------------------------------------------
  // constructor, initialize random generator

  RandomIntGenerator(
    int min,           // minimal random integer to be generated
    int max            // maximal random integer to be generated
  );

  // ------------------------------------------------------------
  // return a random integer number in range [min,max]

  int GetRandomInt();

};

#endif

