#ifndef _SCPP_TCPSock_h
#define _SCPP_TCPSock_h

#include "SocketsGlobal.h"

active class TCPSocket : public UnixSocket {
  int retval;
  struct sockaddr_in server;
  struct in_addr host;
  struct hostent *hent;
  int initfailed;
  
  @TCPSocket();
  
public:
  
/*  UnixSocket::Send;
  UnixSocket::Recv;
  UnixSocket::GetDescr;
*/
  void GetServerStruct(struct sockaddr_in *serv);
  
  ~TCPSocket();

  // Ouverture Passive
  TCPSocket(int ns);

  // Ouverture Active 
  TCPSocket(int &returnV,   // 0: success, -1: init failed
	    char* hostname, // remote hostname
	    int portnum);   // remote server port number
};

active class TCPSocketDaemon {
  
  UnixSocket *sd;
  UnixSocket *ns;
  int nsdesc;
  int retval;
  char nam[20];
  char buf[80];
  struct sockaddr_in sin;
  struct hostent *host;
  struct sockaddr remote;
  int size;
  int initfailed;

  @TCPSocketDaemon();
  
 public: 

  TCPSocket* SocketCreated(struct sockaddr_in *client = NULL);  

  int GetDescr();

  ~TCPSocketDaemon();
  
  TCPSocketDaemon(int & returnV, // 0: success, -1: init failed
		  int portnum);  // listening to local portnumber
};
#endif
