#ifndef __SCPP_libSockets_Global_h
#define __SCPP_libSockets_Global_h

#include <stdio.h>
#include <errno.h>

#ifdef __alpha
extern "C" void           bzero (char *string, int length);
extern "C" int            gethostname (char *name, int namelen);
extern "C" unsigned short htons(unsigned short hostshort) ;
extern "C" unsigned short ntohs ( unsigned short hostshort);
#endif 

// file included by all .cxx file of the libSockets library

int GetSocketsObjectDebug(int myDebugLevel, int debug=0);
int GetSocketsDebug();

inline void serr(char* call) {perror(call);}

#endif
